<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<meta http-equiv="content-type" content="text/html; charset=UTF-8" />
<title>AbstractMultiworkerIOReactor xref</title>
<link type="text/css" rel="stylesheet" href="../../../../../../stylesheet.css" />
</head>
<body>
<div id="overview"><a href="../../../../../../../apidocs/org/apache/http/impl/nio/reactor/AbstractMultiworkerIOReactor.html">View Javadoc</a></div><pre>

<a class="jxr_linenumber" name="1" href="#1">1</a>   <em class="jxr_comment">/*</em>
<a class="jxr_linenumber" name="2" href="#2">2</a>   <em class="jxr_comment"> * ====================================================================</em>
<a class="jxr_linenumber" name="3" href="#3">3</a>   <em class="jxr_comment"> * Licensed to the Apache Software Foundation (ASF) under one</em>
<a class="jxr_linenumber" name="4" href="#4">4</a>   <em class="jxr_comment"> * or more contributor license agreements.  See the NOTICE file</em>
<a class="jxr_linenumber" name="5" href="#5">5</a>   <em class="jxr_comment"> * distributed with this work for additional information</em>
<a class="jxr_linenumber" name="6" href="#6">6</a>   <em class="jxr_comment"> * regarding copyright ownership.  The ASF licenses this file</em>
<a class="jxr_linenumber" name="7" href="#7">7</a>   <em class="jxr_comment"> * to you under the Apache License, Version 2.0 (the</em>
<a class="jxr_linenumber" name="8" href="#8">8</a>   <em class="jxr_comment"> * "License"); you may not use this file except in compliance</em>
<a class="jxr_linenumber" name="9" href="#9">9</a>   <em class="jxr_comment"> * with the License.  You may obtain a copy of the License at</em>
<a class="jxr_linenumber" name="10" href="#10">10</a>  <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="11" href="#11">11</a>  <em class="jxr_comment"> *   <a href="http://www.apache.org/licenses/LICENSE-2.0" target="alexandria_uri">http://www.apache.org/licenses/LICENSE-2.0</a></em>
<a class="jxr_linenumber" name="12" href="#12">12</a>  <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="13" href="#13">13</a>  <em class="jxr_comment"> * Unless required by applicable law or agreed to in writing,</em>
<a class="jxr_linenumber" name="14" href="#14">14</a>  <em class="jxr_comment"> * software distributed under the License is distributed on an</em>
<a class="jxr_linenumber" name="15" href="#15">15</a>  <em class="jxr_comment"> * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY</em>
<a class="jxr_linenumber" name="16" href="#16">16</a>  <em class="jxr_comment"> * KIND, either express or implied.  See the License for the</em>
<a class="jxr_linenumber" name="17" href="#17">17</a>  <em class="jxr_comment"> * specific language governing permissions and limitations</em>
<a class="jxr_linenumber" name="18" href="#18">18</a>  <em class="jxr_comment"> * under the License.</em>
<a class="jxr_linenumber" name="19" href="#19">19</a>  <em class="jxr_comment"> * ====================================================================</em>
<a class="jxr_linenumber" name="20" href="#20">20</a>  <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="21" href="#21">21</a>  <em class="jxr_comment"> * This software consists of voluntary contributions made by many</em>
<a class="jxr_linenumber" name="22" href="#22">22</a>  <em class="jxr_comment"> * individuals on behalf of the Apache Software Foundation.  For more</em>
<a class="jxr_linenumber" name="23" href="#23">23</a>  <em class="jxr_comment"> * information on the Apache Software Foundation, please see</em>
<a class="jxr_linenumber" name="24" href="#24">24</a>  <em class="jxr_comment"> * &lt;<a href="http://www.apache.org/&gt;." target="alexandria_uri">http://www.apache.org/&gt;.</a></em>
<a class="jxr_linenumber" name="25" href="#25">25</a>  <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="26" href="#26">26</a>  <em class="jxr_comment"> */</em>
<a class="jxr_linenumber" name="27" href="#27">27</a>  
<a class="jxr_linenumber" name="28" href="#28">28</a>  <strong class="jxr_keyword">package</strong> org.apache.http.impl.nio.reactor;
<a class="jxr_linenumber" name="29" href="#29">29</a>  
<a class="jxr_linenumber" name="30" href="#30">30</a>  <strong class="jxr_keyword">import</strong> java.io.IOException;
<a class="jxr_linenumber" name="31" href="#31">31</a>  <strong class="jxr_keyword">import</strong> java.io.InterruptedIOException;
<a class="jxr_linenumber" name="32" href="#32">32</a>  <strong class="jxr_keyword">import</strong> java.net.Socket;
<a class="jxr_linenumber" name="33" href="#33">33</a>  <strong class="jxr_keyword">import</strong> java.nio.channels.Channel;
<a class="jxr_linenumber" name="34" href="#34">34</a>  <strong class="jxr_keyword">import</strong> java.nio.channels.ClosedChannelException;
<a class="jxr_linenumber" name="35" href="#35">35</a>  <strong class="jxr_keyword">import</strong> java.nio.channels.ClosedSelectorException;
<a class="jxr_linenumber" name="36" href="#36">36</a>  <strong class="jxr_keyword">import</strong> java.nio.channels.SelectableChannel;
<a class="jxr_linenumber" name="37" href="#37">37</a>  <strong class="jxr_keyword">import</strong> java.nio.channels.SelectionKey;
<a class="jxr_linenumber" name="38" href="#38">38</a>  <strong class="jxr_keyword">import</strong> java.nio.channels.Selector;
<a class="jxr_linenumber" name="39" href="#39">39</a>  <strong class="jxr_keyword">import</strong> java.util.ArrayList;
<a class="jxr_linenumber" name="40" href="#40">40</a>  <strong class="jxr_keyword">import</strong> java.util.Date;
<a class="jxr_linenumber" name="41" href="#41">41</a>  <strong class="jxr_keyword">import</strong> java.util.List;
<a class="jxr_linenumber" name="42" href="#42">42</a>  <strong class="jxr_keyword">import</strong> java.util.concurrent.ThreadFactory;
<a class="jxr_linenumber" name="43" href="#43">43</a>  
<a class="jxr_linenumber" name="44" href="#44">44</a>  <strong class="jxr_keyword">import</strong> org.apache.http.annotation.ThreadSafe;
<a class="jxr_linenumber" name="45" href="#45">45</a>  <strong class="jxr_keyword">import</strong> org.apache.http.nio.params.NIOReactorParams;
<a class="jxr_linenumber" name="46" href="#46">46</a>  <strong class="jxr_keyword">import</strong> org.apache.http.nio.reactor.IOEventDispatch;
<a class="jxr_linenumber" name="47" href="#47">47</a>  <strong class="jxr_keyword">import</strong> org.apache.http.nio.reactor.IOReactor;
<a class="jxr_linenumber" name="48" href="#48">48</a>  <strong class="jxr_keyword">import</strong> org.apache.http.nio.reactor.IOReactorException;
<a class="jxr_linenumber" name="49" href="#49">49</a>  <strong class="jxr_keyword">import</strong> org.apache.http.nio.reactor.IOReactorExceptionHandler;
<a class="jxr_linenumber" name="50" href="#50">50</a>  <strong class="jxr_keyword">import</strong> org.apache.http.nio.reactor.IOReactorStatus;
<a class="jxr_linenumber" name="51" href="#51">51</a>  <strong class="jxr_keyword">import</strong> org.apache.http.params.BasicHttpParams;
<a class="jxr_linenumber" name="52" href="#52">52</a>  <strong class="jxr_keyword">import</strong> org.apache.http.params.HttpConnectionParams;
<a class="jxr_linenumber" name="53" href="#53">53</a>  <strong class="jxr_keyword">import</strong> org.apache.http.params.HttpParams;
<a class="jxr_linenumber" name="54" href="#54">54</a>  <strong class="jxr_keyword">import</strong> org.apache.http.util.Args;
<a class="jxr_linenumber" name="55" href="#55">55</a>  
<a class="jxr_linenumber" name="56" href="#56">56</a>  <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="57" href="#57">57</a>  <em class="jxr_javadoccomment"> * Generic implementation of {@link IOReactor} that can run multiple</em>
<a class="jxr_linenumber" name="58" href="#58">58</a>  <em class="jxr_javadoccomment"> * {@link BaseIOReactor} instance in separate worker threads and distribute</em>
<a class="jxr_linenumber" name="59" href="#59">59</a>  <em class="jxr_javadoccomment"> * newly created I/O session equally across those I/O reactors for a more</em>
<a class="jxr_linenumber" name="60" href="#60">60</a>  <em class="jxr_javadoccomment"> * optimal resource utilization and a better I/O performance. Usually it is</em>
<a class="jxr_linenumber" name="61" href="#61">61</a>  <em class="jxr_javadoccomment"> * recommended to have one worker I/O reactor per physical CPU core.</em>
<a class="jxr_linenumber" name="62" href="#62">62</a>  <em class="jxr_javadoccomment"> * &lt;p&gt;</em>
<a class="jxr_linenumber" name="63" href="#63">63</a>  <em class="jxr_javadoccomment"> * &lt;strong&gt;Important note about exception handling&lt;/strong&gt;</em>
<a class="jxr_linenumber" name="64" href="#64">64</a>  <em class="jxr_javadoccomment"> * &lt;p&gt;</em>
<a class="jxr_linenumber" name="65" href="#65">65</a>  <em class="jxr_javadoccomment"> * Protocol specific exceptions as well as those I/O exceptions thrown in the</em>
<a class="jxr_linenumber" name="66" href="#66">66</a>  <em class="jxr_javadoccomment"> * course of interaction with the session's channel are to be expected are to be</em>
<a class="jxr_linenumber" name="67" href="#67">67</a>  <em class="jxr_javadoccomment"> * dealt with by specific protocol handlers. These exceptions may result in</em>
<a class="jxr_linenumber" name="68" href="#68">68</a>  <em class="jxr_javadoccomment"> * termination of an individual session but should not affect the I/O reactor</em>
<a class="jxr_linenumber" name="69" href="#69">69</a>  <em class="jxr_javadoccomment"> * and all other active sessions. There are situations, however, when the I/O</em>
<a class="jxr_linenumber" name="70" href="#70">70</a>  <em class="jxr_javadoccomment"> * reactor itself encounters an internal problem such as an I/O exception in</em>
<a class="jxr_linenumber" name="71" href="#71">71</a>  <em class="jxr_javadoccomment"> * the underlying NIO classes or an unhandled runtime exception. Those types of</em>
<a class="jxr_linenumber" name="72" href="#72">72</a>  <em class="jxr_javadoccomment"> * exceptions are usually fatal and will cause the I/O reactor to shut down</em>
<a class="jxr_linenumber" name="73" href="#73">73</a>  <em class="jxr_javadoccomment"> * automatically.</em>
<a class="jxr_linenumber" name="74" href="#74">74</a>  <em class="jxr_javadoccomment"> * &lt;p&gt;</em>
<a class="jxr_linenumber" name="75" href="#75">75</a>  <em class="jxr_javadoccomment"> * There is a possibility to override this behavior and prevent I/O reactors</em>
<a class="jxr_linenumber" name="76" href="#76">76</a>  <em class="jxr_javadoccomment"> * from shutting down automatically in case of a runtime exception or an I/O</em>
<a class="jxr_linenumber" name="77" href="#77">77</a>  <em class="jxr_javadoccomment"> * exception in internal classes. This can be accomplished by providing a custom</em>
<a class="jxr_linenumber" name="78" href="#78">78</a>  <em class="jxr_javadoccomment"> * implementation of the {@link IOReactorExceptionHandler} interface.</em>
<a class="jxr_linenumber" name="79" href="#79">79</a>  <em class="jxr_javadoccomment"> * &lt;p&gt;</em>
<a class="jxr_linenumber" name="80" href="#80">80</a>  <em class="jxr_javadoccomment"> * If an I/O reactor is unable to automatically recover from an I/O or a runtime</em>
<a class="jxr_linenumber" name="81" href="#81">81</a>  <em class="jxr_javadoccomment"> * exception it will enter the shutdown mode. First off, it cancel all pending</em>
<a class="jxr_linenumber" name="82" href="#82">82</a>  <em class="jxr_javadoccomment"> * new session requests. Then it will attempt to close all active I/O sessions</em>
<a class="jxr_linenumber" name="83" href="#83">83</a>  <em class="jxr_javadoccomment"> * gracefully giving them some time to flush pending output data and terminate</em>
<a class="jxr_linenumber" name="84" href="#84">84</a>  <em class="jxr_javadoccomment"> * cleanly. Lastly, it will forcibly shut down those I/O sessions that still</em>
<a class="jxr_linenumber" name="85" href="#85">85</a>  <em class="jxr_javadoccomment"> * remain active after the grace period. This is a fairly complex process, where</em>
<a class="jxr_linenumber" name="86" href="#86">86</a>  <em class="jxr_javadoccomment"> * many things can fail at the same time and many different exceptions can be</em>
<a class="jxr_linenumber" name="87" href="#87">87</a>  <em class="jxr_javadoccomment"> * thrown in the course of the shutdown process. The I/O reactor will record all</em>
<a class="jxr_linenumber" name="88" href="#88">88</a>  <em class="jxr_javadoccomment"> * exceptions thrown during the shutdown process, including the original one</em>
<a class="jxr_linenumber" name="89" href="#89">89</a>  <em class="jxr_javadoccomment"> * that actually caused the shutdown in the first place, in an audit log. One</em>
<a class="jxr_linenumber" name="90" href="#90">90</a>  <em class="jxr_javadoccomment"> * can obtain the audit log using {@link #getAuditLog()}, examine exceptions</em>
<a class="jxr_linenumber" name="91" href="#91">91</a>  <em class="jxr_javadoccomment"> * thrown by the I/O reactor prior and in the course of the reactor shutdown</em>
<a class="jxr_linenumber" name="92" href="#92">92</a>  <em class="jxr_javadoccomment"> * and decide whether it is safe to restart the I/O reactor.</em>
<a class="jxr_linenumber" name="93" href="#93">93</a>  <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="94" href="#94">94</a>  <em class="jxr_javadoccomment"> * @since 4.0</em>
<a class="jxr_linenumber" name="95" href="#95">95</a>  <em class="jxr_javadoccomment"> */</em>
<a class="jxr_linenumber" name="96" href="#96">96</a>  @SuppressWarnings(<span class="jxr_string">"deprecation"</span>)
<a class="jxr_linenumber" name="97" href="#97">97</a>  @ThreadSafe <em class="jxr_comment">// public methods only</em>
<a class="jxr_linenumber" name="98" href="#98">98</a>  <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">abstract</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../../../org/apache/http/impl/nio/reactor/AbstractMultiworkerIOReactor.html">AbstractMultiworkerIOReactor</a> <strong class="jxr_keyword">implements</strong> <a href="../../../../../../org/apache/http/nio/reactor/IOReactor.html">IOReactor</a> {
<a class="jxr_linenumber" name="99" href="#99">99</a>  
<a class="jxr_linenumber" name="100" href="#100">100</a>     <strong class="jxr_keyword">protected</strong> <strong class="jxr_keyword">volatile</strong> <a href="../../../../../../org/apache/http/nio/reactor/IOReactorStatus.html">IOReactorStatus</a> status;
<a class="jxr_linenumber" name="101" href="#101">101</a> 
<a class="jxr_linenumber" name="102" href="#102">102</a>     <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="103" href="#103">103</a> <em class="jxr_javadoccomment">     * @deprecated (4.2)</em>
<a class="jxr_linenumber" name="104" href="#104">104</a> <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="105" href="#105">105</a>     @Deprecated
<a class="jxr_linenumber" name="106" href="#106">106</a>     <strong class="jxr_keyword">protected</strong> <strong class="jxr_keyword">final</strong> HttpParams params;
<a class="jxr_linenumber" name="107" href="#107">107</a>     <strong class="jxr_keyword">protected</strong> <strong class="jxr_keyword">final</strong> <a href="../../../../../../org/apache/http/impl/nio/reactor/IOReactorConfig.html">IOReactorConfig</a> config;
<a class="jxr_linenumber" name="108" href="#108">108</a>     <strong class="jxr_keyword">protected</strong> <strong class="jxr_keyword">final</strong> Selector selector;
<a class="jxr_linenumber" name="109" href="#109">109</a>     <strong class="jxr_keyword">protected</strong> <strong class="jxr_keyword">final</strong> <strong class="jxr_keyword">long</strong> selectTimeout;
<a class="jxr_linenumber" name="110" href="#110">110</a>     <strong class="jxr_keyword">protected</strong> <strong class="jxr_keyword">final</strong> <strong class="jxr_keyword">boolean</strong> interestOpsQueueing;
<a class="jxr_linenumber" name="111" href="#111">111</a> 
<a class="jxr_linenumber" name="112" href="#112">112</a>     <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">final</strong> <strong class="jxr_keyword">int</strong> workerCount;
<a class="jxr_linenumber" name="113" href="#113">113</a>     <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">final</strong> ThreadFactory threadFactory;
<a class="jxr_linenumber" name="114" href="#114">114</a>     <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">final</strong> <a href="../../../../../../org/apache/http/impl/nio/reactor/BaseIOReactor.html">BaseIOReactor</a>[] dispatchers;
<a class="jxr_linenumber" name="115" href="#115">115</a>     <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">final</strong> <a href="../../../../../../org/apache/http/impl/nio/reactor/AbstractMultiworkerIOReactor.html">Worker</a>[] workers;
<a class="jxr_linenumber" name="116" href="#116">116</a>     <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">final</strong> Thread[] threads;
<a class="jxr_linenumber" name="117" href="#117">117</a>     <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">final</strong> Object statusLock;
<a class="jxr_linenumber" name="118" href="#118">118</a> 
<a class="jxr_linenumber" name="119" href="#119">119</a>     <strong class="jxr_keyword">protected</strong> <a href="../../../../../../org/apache/http/nio/reactor/IOReactorExceptionHandler.html">IOReactorExceptionHandler</a> exceptionHandler;
<a class="jxr_linenumber" name="120" href="#120">120</a>     <strong class="jxr_keyword">protected</strong> List&lt;ExceptionEvent&gt; auditLog;
<a class="jxr_linenumber" name="121" href="#121">121</a> 
<a class="jxr_linenumber" name="122" href="#122">122</a>     <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">int</strong> currentWorker = 0;
<a class="jxr_linenumber" name="123" href="#123">123</a> 
<a class="jxr_linenumber" name="124" href="#124">124</a>     <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="125" href="#125">125</a> <em class="jxr_javadoccomment">     * Creates an instance of AbstractMultiworkerIOReactor with the given configuration.</em>
<a class="jxr_linenumber" name="126" href="#126">126</a> <em class="jxr_javadoccomment">     *</em>
<a class="jxr_linenumber" name="127" href="#127">127</a> <em class="jxr_javadoccomment">     * @param config I/O reactor configuration.</em>
<a class="jxr_linenumber" name="128" href="#128">128</a> <em class="jxr_javadoccomment">     * @param threadFactory the factory to create threads.</em>
<a class="jxr_linenumber" name="129" href="#129">129</a> <em class="jxr_javadoccomment">     *   Can be &lt;code&gt;null&lt;/code&gt;.</em>
<a class="jxr_linenumber" name="130" href="#130">130</a> <em class="jxr_javadoccomment">     * @throws IOReactorException in case if a non-recoverable I/O error.</em>
<a class="jxr_linenumber" name="131" href="#131">131</a> <em class="jxr_javadoccomment">     *</em>
<a class="jxr_linenumber" name="132" href="#132">132</a> <em class="jxr_javadoccomment">     * @since 4.2</em>
<a class="jxr_linenumber" name="133" href="#133">133</a> <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="134" href="#134">134</a>     <strong class="jxr_keyword">public</strong> <a href="../../../../../../org/apache/http/impl/nio/reactor/AbstractMultiworkerIOReactor.html">AbstractMultiworkerIOReactor</a>(
<a class="jxr_linenumber" name="135" href="#135">135</a>             <strong class="jxr_keyword">final</strong> <a href="../../../../../../org/apache/http/impl/nio/reactor/IOReactorConfig.html">IOReactorConfig</a> config,
<a class="jxr_linenumber" name="136" href="#136">136</a>             <strong class="jxr_keyword">final</strong> ThreadFactory threadFactory) <strong class="jxr_keyword">throws</strong> IOReactorException {
<a class="jxr_linenumber" name="137" href="#137">137</a>         <strong class="jxr_keyword">super</strong>();
<a class="jxr_linenumber" name="138" href="#138">138</a>         <strong class="jxr_keyword">this</strong>.config = config != <strong class="jxr_keyword">null</strong> ? config : IOReactorConfig.DEFAULT;
<a class="jxr_linenumber" name="139" href="#139">139</a>         <strong class="jxr_keyword">this</strong>.params = <strong class="jxr_keyword">new</strong> BasicHttpParams();
<a class="jxr_linenumber" name="140" href="#140">140</a>         <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="141" href="#141">141</a>             <strong class="jxr_keyword">this</strong>.selector = Selector.open();
<a class="jxr_linenumber" name="142" href="#142">142</a>         } <strong class="jxr_keyword">catch</strong> (IOException ex) {
<a class="jxr_linenumber" name="143" href="#143">143</a>             <strong class="jxr_keyword">throw</strong> <strong class="jxr_keyword">new</strong> <a href="../../../../../../org/apache/http/nio/reactor/IOReactorException.html">IOReactorException</a>(<span class="jxr_string">"Failure opening selector"</span>, ex);
<a class="jxr_linenumber" name="144" href="#144">144</a>         }
<a class="jxr_linenumber" name="145" href="#145">145</a>         <strong class="jxr_keyword">this</strong>.selectTimeout = <strong class="jxr_keyword">this</strong>.config.getSelectInterval();
<a class="jxr_linenumber" name="146" href="#146">146</a>         <strong class="jxr_keyword">this</strong>.interestOpsQueueing = <strong class="jxr_keyword">this</strong>.config.isInterestOpQueued();
<a class="jxr_linenumber" name="147" href="#147">147</a>         <strong class="jxr_keyword">this</strong>.statusLock = <strong class="jxr_keyword">new</strong> Object();
<a class="jxr_linenumber" name="148" href="#148">148</a>         <strong class="jxr_keyword">if</strong> (threadFactory != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="149" href="#149">149</a>             <strong class="jxr_keyword">this</strong>.threadFactory = threadFactory;
<a class="jxr_linenumber" name="150" href="#150">150</a>         } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="151" href="#151">151</a>             <strong class="jxr_keyword">this</strong>.threadFactory = <strong class="jxr_keyword">new</strong> <a href="../../../../../../org/apache/http/impl/nio/reactor/AbstractMultiworkerIOReactor.html">DefaultThreadFactory</a>();
<a class="jxr_linenumber" name="152" href="#152">152</a>         }
<a class="jxr_linenumber" name="153" href="#153">153</a>         <strong class="jxr_keyword">this</strong>.workerCount = <strong class="jxr_keyword">this</strong>.config.getIoThreadCount();
<a class="jxr_linenumber" name="154" href="#154">154</a>         <strong class="jxr_keyword">this</strong>.dispatchers = <strong class="jxr_keyword">new</strong> <a href="../../../../../../org/apache/http/impl/nio/reactor/BaseIOReactor.html">BaseIOReactor</a>[workerCount];
<a class="jxr_linenumber" name="155" href="#155">155</a>         <strong class="jxr_keyword">this</strong>.workers = <strong class="jxr_keyword">new</strong> <a href="../../../../../../org/apache/http/impl/nio/reactor/AbstractMultiworkerIOReactor.html">Worker</a>[workerCount];
<a class="jxr_linenumber" name="156" href="#156">156</a>         <strong class="jxr_keyword">this</strong>.threads = <strong class="jxr_keyword">new</strong> Thread[workerCount];
<a class="jxr_linenumber" name="157" href="#157">157</a>         <strong class="jxr_keyword">this</strong>.status = IOReactorStatus.INACTIVE;
<a class="jxr_linenumber" name="158" href="#158">158</a>     }
<a class="jxr_linenumber" name="159" href="#159">159</a> 
<a class="jxr_linenumber" name="160" href="#160">160</a>     <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="161" href="#161">161</a> <em class="jxr_javadoccomment">     * Creates an instance of AbstractMultiworkerIOReactor with default configuration.</em>
<a class="jxr_linenumber" name="162" href="#162">162</a> <em class="jxr_javadoccomment">     *</em>
<a class="jxr_linenumber" name="163" href="#163">163</a> <em class="jxr_javadoccomment">     * @throws IOReactorException in case if a non-recoverable I/O error.</em>
<a class="jxr_linenumber" name="164" href="#164">164</a> <em class="jxr_javadoccomment">     *</em>
<a class="jxr_linenumber" name="165" href="#165">165</a> <em class="jxr_javadoccomment">     * @since 4.2</em>
<a class="jxr_linenumber" name="166" href="#166">166</a> <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="167" href="#167">167</a>     <strong class="jxr_keyword">public</strong> <a href="../../../../../../org/apache/http/impl/nio/reactor/AbstractMultiworkerIOReactor.html">AbstractMultiworkerIOReactor</a>() <strong class="jxr_keyword">throws</strong> IOReactorException {
<a class="jxr_linenumber" name="168" href="#168">168</a>         <strong class="jxr_keyword">this</strong>(<strong class="jxr_keyword">null</strong>, <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="169" href="#169">169</a>     }
<a class="jxr_linenumber" name="170" href="#170">170</a> 
<a class="jxr_linenumber" name="171" href="#171">171</a>     <strong class="jxr_keyword">static</strong> <a href="../../../../../../org/apache/http/impl/nio/reactor/IOReactorConfig.html">IOReactorConfig</a> convert(<strong class="jxr_keyword">int</strong> workerCount, <strong class="jxr_keyword">final</strong> HttpParams params) {
<a class="jxr_linenumber" name="172" href="#172">172</a>         Args.notNull(params, <span class="jxr_string">"HTTP parameters"</span>);
<a class="jxr_linenumber" name="173" href="#173">173</a>         <a href="../../../../../../org/apache/http/impl/nio/reactor/IOReactorConfig.html">IOReactorConfig</a> config = IOReactorConfig.custom()
<a class="jxr_linenumber" name="174" href="#174">174</a>             .setSelectInterval(NIOReactorParams.getSelectInterval(params))
<a class="jxr_linenumber" name="175" href="#175">175</a>             .setShutdownGracePeriod(NIOReactorParams.getGracePeriod(params))
<a class="jxr_linenumber" name="176" href="#176">176</a>             .setInterestOpQueued(NIOReactorParams.getInterestOpsQueueing(params))
<a class="jxr_linenumber" name="177" href="#177">177</a>             .setIoThreadCount(workerCount)
<a class="jxr_linenumber" name="178" href="#178">178</a>             .setTcpNoDelay(HttpConnectionParams.getTcpNoDelay(params))
<a class="jxr_linenumber" name="179" href="#179">179</a>             .setSoTimeout(HttpConnectionParams.getSoTimeout(params))
<a class="jxr_linenumber" name="180" href="#180">180</a>             .setSoLinger(HttpConnectionParams.getLinger(params))
<a class="jxr_linenumber" name="181" href="#181">181</a>             .setSoKeepAlive(HttpConnectionParams.getSoKeepalive(params))
<a class="jxr_linenumber" name="182" href="#182">182</a>             .setConnectTimeout(HttpConnectionParams.getConnectionTimeout(params))
<a class="jxr_linenumber" name="183" href="#183">183</a>             .setSoReuseAddress(HttpConnectionParams.getSoReuseaddr(params))
<a class="jxr_linenumber" name="184" href="#184">184</a>             .build();
<a class="jxr_linenumber" name="185" href="#185">185</a> 
<a class="jxr_linenumber" name="186" href="#186">186</a>         <strong class="jxr_keyword">return</strong> config;
<a class="jxr_linenumber" name="187" href="#187">187</a>     }
<a class="jxr_linenumber" name="188" href="#188">188</a> 
<a class="jxr_linenumber" name="189" href="#189">189</a>     <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="190" href="#190">190</a> <em class="jxr_javadoccomment">     * Creates an instance of AbstractMultiworkerIOReactor.</em>
<a class="jxr_linenumber" name="191" href="#191">191</a> <em class="jxr_javadoccomment">     *</em>
<a class="jxr_linenumber" name="192" href="#192">192</a> <em class="jxr_javadoccomment">     * @param workerCount number of worker I/O reactors.</em>
<a class="jxr_linenumber" name="193" href="#193">193</a> <em class="jxr_javadoccomment">     * @param threadFactory the factory to create threads.</em>
<a class="jxr_linenumber" name="194" href="#194">194</a> <em class="jxr_javadoccomment">     *   Can be &lt;code&gt;null&lt;/code&gt;.</em>
<a class="jxr_linenumber" name="195" href="#195">195</a> <em class="jxr_javadoccomment">     * @param params HTTP parameters.</em>
<a class="jxr_linenumber" name="196" href="#196">196</a> <em class="jxr_javadoccomment">     * @throws IOReactorException in case if a non-recoverable I/O error.</em>
<a class="jxr_linenumber" name="197" href="#197">197</a> <em class="jxr_javadoccomment">     *</em>
<a class="jxr_linenumber" name="198" href="#198">198</a> <em class="jxr_javadoccomment">     * @deprecated (4.2) use {@link AbstractMultiworkerIOReactor#AbstractMultiworkerIOReactor(IOReactorConfig, ThreadFactory)}</em>
<a class="jxr_linenumber" name="199" href="#199">199</a> <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="200" href="#200">200</a>     @Deprecated
<a class="jxr_linenumber" name="201" href="#201">201</a>     <strong class="jxr_keyword">public</strong> <a href="../../../../../../org/apache/http/impl/nio/reactor/AbstractMultiworkerIOReactor.html">AbstractMultiworkerIOReactor</a>(
<a class="jxr_linenumber" name="202" href="#202">202</a>             <strong class="jxr_keyword">int</strong> workerCount,
<a class="jxr_linenumber" name="203" href="#203">203</a>             <strong class="jxr_keyword">final</strong> ThreadFactory threadFactory,
<a class="jxr_linenumber" name="204" href="#204">204</a>             <strong class="jxr_keyword">final</strong> HttpParams params) <strong class="jxr_keyword">throws</strong> IOReactorException {
<a class="jxr_linenumber" name="205" href="#205">205</a>         <strong class="jxr_keyword">this</strong>(convert(workerCount, params), threadFactory);
<a class="jxr_linenumber" name="206" href="#206">206</a>     }
<a class="jxr_linenumber" name="207" href="#207">207</a> 
<a class="jxr_linenumber" name="208" href="#208">208</a>     <strong class="jxr_keyword">public</strong> <a href="../../../../../../org/apache/http/nio/reactor/IOReactorStatus.html">IOReactorStatus</a> getStatus() {
<a class="jxr_linenumber" name="209" href="#209">209</a>         <strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">this</strong>.status;
<a class="jxr_linenumber" name="210" href="#210">210</a>     }
<a class="jxr_linenumber" name="211" href="#211">211</a> 
<a class="jxr_linenumber" name="212" href="#212">212</a>     <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="213" href="#213">213</a> <em class="jxr_javadoccomment">     * Returns the audit log containing exceptions thrown by the I/O reactor</em>
<a class="jxr_linenumber" name="214" href="#214">214</a> <em class="jxr_javadoccomment">     * prior and in the course of the reactor shutdown.</em>
<a class="jxr_linenumber" name="215" href="#215">215</a> <em class="jxr_javadoccomment">     *</em>
<a class="jxr_linenumber" name="216" href="#216">216</a> <em class="jxr_javadoccomment">     * @return audit log.</em>
<a class="jxr_linenumber" name="217" href="#217">217</a> <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="218" href="#218">218</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">synchronized</strong> List&lt;ExceptionEvent&gt; getAuditLog() {
<a class="jxr_linenumber" name="219" href="#219">219</a>         <strong class="jxr_keyword">if</strong> (<strong class="jxr_keyword">this</strong>.auditLog != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="220" href="#220">220</a>             <strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">new</strong> ArrayList&lt;ExceptionEvent&gt;(<strong class="jxr_keyword">this</strong>.auditLog);
<a class="jxr_linenumber" name="221" href="#221">221</a>         } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="222" href="#222">222</a>             <strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="223" href="#223">223</a>         }
<a class="jxr_linenumber" name="224" href="#224">224</a>     }
<a class="jxr_linenumber" name="225" href="#225">225</a> 
<a class="jxr_linenumber" name="226" href="#226">226</a>     <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="227" href="#227">227</a> <em class="jxr_javadoccomment">     * Adds the given {@link Throwable} object with the given time stamp</em>
<a class="jxr_linenumber" name="228" href="#228">228</a> <em class="jxr_javadoccomment">     * to the audit log.</em>
<a class="jxr_linenumber" name="229" href="#229">229</a> <em class="jxr_javadoccomment">     *</em>
<a class="jxr_linenumber" name="230" href="#230">230</a> <em class="jxr_javadoccomment">     * @param ex the exception thrown by the I/O reactor.</em>
<a class="jxr_linenumber" name="231" href="#231">231</a> <em class="jxr_javadoccomment">     * @param timestamp the time stamp of the exception. Can be</em>
<a class="jxr_linenumber" name="232" href="#232">232</a> <em class="jxr_javadoccomment">     * &lt;code&gt;null&lt;/code&gt; in which case the current date / time will be used.</em>
<a class="jxr_linenumber" name="233" href="#233">233</a> <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="234" href="#234">234</a>     <strong class="jxr_keyword">protected</strong> <strong class="jxr_keyword">synchronized</strong> <strong class="jxr_keyword">void</strong> addExceptionEvent(<strong class="jxr_keyword">final</strong> Throwable ex, Date timestamp) {
<a class="jxr_linenumber" name="235" href="#235">235</a>         <strong class="jxr_keyword">if</strong> (ex == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="236" href="#236">236</a>             <strong class="jxr_keyword">return</strong>;
<a class="jxr_linenumber" name="237" href="#237">237</a>         }
<a class="jxr_linenumber" name="238" href="#238">238</a>         <strong class="jxr_keyword">if</strong> (timestamp == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="239" href="#239">239</a>             timestamp = <strong class="jxr_keyword">new</strong> Date();
<a class="jxr_linenumber" name="240" href="#240">240</a>         }
<a class="jxr_linenumber" name="241" href="#241">241</a>         <strong class="jxr_keyword">if</strong> (<strong class="jxr_keyword">this</strong>.auditLog == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="242" href="#242">242</a>             <strong class="jxr_keyword">this</strong>.auditLog = <strong class="jxr_keyword">new</strong> ArrayList&lt;ExceptionEvent&gt;();
<a class="jxr_linenumber" name="243" href="#243">243</a>         }
<a class="jxr_linenumber" name="244" href="#244">244</a>         <strong class="jxr_keyword">this</strong>.auditLog.add(<strong class="jxr_keyword">new</strong> <a href="../../../../../../org/apache/http/impl/nio/reactor/ExceptionEvent.html">ExceptionEvent</a>(ex, timestamp));
<a class="jxr_linenumber" name="245" href="#245">245</a>     }
<a class="jxr_linenumber" name="246" href="#246">246</a> 
<a class="jxr_linenumber" name="247" href="#247">247</a>     <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="248" href="#248">248</a> <em class="jxr_javadoccomment">     * Adds the given {@link Throwable} object to the audit log.</em>
<a class="jxr_linenumber" name="249" href="#249">249</a> <em class="jxr_javadoccomment">     *</em>
<a class="jxr_linenumber" name="250" href="#250">250</a> <em class="jxr_javadoccomment">     * @param ex the exception thrown by the I/O reactor.</em>
<a class="jxr_linenumber" name="251" href="#251">251</a> <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="252" href="#252">252</a>     <strong class="jxr_keyword">protected</strong> <strong class="jxr_keyword">void</strong> addExceptionEvent(<strong class="jxr_keyword">final</strong> Throwable ex) {
<a class="jxr_linenumber" name="253" href="#253">253</a>         addExceptionEvent(ex, <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="254" href="#254">254</a>     }
<a class="jxr_linenumber" name="255" href="#255">255</a> 
<a class="jxr_linenumber" name="256" href="#256">256</a>     <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="257" href="#257">257</a> <em class="jxr_javadoccomment">     * Sets exception handler for this I/O reactor.</em>
<a class="jxr_linenumber" name="258" href="#258">258</a> <em class="jxr_javadoccomment">     *</em>
<a class="jxr_linenumber" name="259" href="#259">259</a> <em class="jxr_javadoccomment">     * @param exceptionHandler the exception handler.</em>
<a class="jxr_linenumber" name="260" href="#260">260</a> <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="261" href="#261">261</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> setExceptionHandler(<strong class="jxr_keyword">final</strong> <a href="../../../../../../org/apache/http/nio/reactor/IOReactorExceptionHandler.html">IOReactorExceptionHandler</a> exceptionHandler) {
<a class="jxr_linenumber" name="262" href="#262">262</a>         <strong class="jxr_keyword">this</strong>.exceptionHandler = exceptionHandler;
<a class="jxr_linenumber" name="263" href="#263">263</a>     }
<a class="jxr_linenumber" name="264" href="#264">264</a> 
<a class="jxr_linenumber" name="265" href="#265">265</a>     <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="266" href="#266">266</a> <em class="jxr_javadoccomment">     * Triggered to process I/O events registered by the main {@link Selector}.</em>
<a class="jxr_linenumber" name="267" href="#267">267</a> <em class="jxr_javadoccomment">     * &lt;p&gt;</em>
<a class="jxr_linenumber" name="268" href="#268">268</a> <em class="jxr_javadoccomment">     * Super-classes can implement this method to react to the event.</em>
<a class="jxr_linenumber" name="269" href="#269">269</a> <em class="jxr_javadoccomment">     *</em>
<a class="jxr_linenumber" name="270" href="#270">270</a> <em class="jxr_javadoccomment">     * @param count event count.</em>
<a class="jxr_linenumber" name="271" href="#271">271</a> <em class="jxr_javadoccomment">     * @throws IOReactorException in case if a non-recoverable I/O error.</em>
<a class="jxr_linenumber" name="272" href="#272">272</a> <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="273" href="#273">273</a>     <strong class="jxr_keyword">protected</strong> <strong class="jxr_keyword">abstract</strong> <strong class="jxr_keyword">void</strong> processEvents(<strong class="jxr_keyword">int</strong> count) <strong class="jxr_keyword">throws</strong> IOReactorException;
<a class="jxr_linenumber" name="274" href="#274">274</a> 
<a class="jxr_linenumber" name="275" href="#275">275</a>     <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="276" href="#276">276</a> <em class="jxr_javadoccomment">     * Triggered to cancel pending session requests.</em>
<a class="jxr_linenumber" name="277" href="#277">277</a> <em class="jxr_javadoccomment">     * &lt;p&gt;</em>
<a class="jxr_linenumber" name="278" href="#278">278</a> <em class="jxr_javadoccomment">     * Super-classes can implement this method to react to the event.</em>
<a class="jxr_linenumber" name="279" href="#279">279</a> <em class="jxr_javadoccomment">     *</em>
<a class="jxr_linenumber" name="280" href="#280">280</a> <em class="jxr_javadoccomment">     * @throws IOReactorException in case if a non-recoverable I/O error.</em>
<a class="jxr_linenumber" name="281" href="#281">281</a> <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="282" href="#282">282</a>     <strong class="jxr_keyword">protected</strong> <strong class="jxr_keyword">abstract</strong> <strong class="jxr_keyword">void</strong> cancelRequests() <strong class="jxr_keyword">throws</strong> IOReactorException;
<a class="jxr_linenumber" name="283" href="#283">283</a> 
<a class="jxr_linenumber" name="284" href="#284">284</a>     <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="285" href="#285">285</a> <em class="jxr_javadoccomment">     * Activates the main I/O reactor as well as all worker I/O reactors.</em>
<a class="jxr_linenumber" name="286" href="#286">286</a> <em class="jxr_javadoccomment">     * The I/O main reactor will start reacting to I/O events and triggering</em>
<a class="jxr_linenumber" name="287" href="#287">287</a> <em class="jxr_javadoccomment">     * notification methods. The worker I/O reactor in their turn will start</em>
<a class="jxr_linenumber" name="288" href="#288">288</a> <em class="jxr_javadoccomment">     * reacting to I/O events and dispatch I/O event notifications to the given</em>
<a class="jxr_linenumber" name="289" href="#289">289</a> <em class="jxr_javadoccomment">     * {@link IOEventDispatch} interface.</em>
<a class="jxr_linenumber" name="290" href="#290">290</a> <em class="jxr_javadoccomment">     * &lt;p&gt;</em>
<a class="jxr_linenumber" name="291" href="#291">291</a> <em class="jxr_javadoccomment">     * This method will enter the infinite I/O select loop on</em>
<a class="jxr_linenumber" name="292" href="#292">292</a> <em class="jxr_javadoccomment">     * the {@link Selector} instance associated with this I/O reactor and used</em>
<a class="jxr_linenumber" name="293" href="#293">293</a> <em class="jxr_javadoccomment">     * to manage creation of new I/O channels. Once a new I/O channel has been</em>
<a class="jxr_linenumber" name="294" href="#294">294</a> <em class="jxr_javadoccomment">     * created the processing of I/O events on that channel will be delegated</em>
<a class="jxr_linenumber" name="295" href="#295">295</a> <em class="jxr_javadoccomment">     * to one of the worker I/O reactors.</em>
<a class="jxr_linenumber" name="296" href="#296">296</a> <em class="jxr_javadoccomment">     * &lt;p&gt;</em>
<a class="jxr_linenumber" name="297" href="#297">297</a> <em class="jxr_javadoccomment">     * The method will remain blocked unto the I/O reactor is shut down or the</em>
<a class="jxr_linenumber" name="298" href="#298">298</a> <em class="jxr_javadoccomment">     * execution thread is interrupted.</em>
<a class="jxr_linenumber" name="299" href="#299">299</a> <em class="jxr_javadoccomment">     *</em>
<a class="jxr_linenumber" name="300" href="#300">300</a> <em class="jxr_javadoccomment">     * @see #processEvents(int)</em>
<a class="jxr_linenumber" name="301" href="#301">301</a> <em class="jxr_javadoccomment">     * @see #cancelRequests()</em>
<a class="jxr_linenumber" name="302" href="#302">302</a> <em class="jxr_javadoccomment">     *</em>
<a class="jxr_linenumber" name="303" href="#303">303</a> <em class="jxr_javadoccomment">     * @throws InterruptedIOException if the dispatch thread is interrupted.</em>
<a class="jxr_linenumber" name="304" href="#304">304</a> <em class="jxr_javadoccomment">     * @throws IOReactorException in case if a non-recoverable I/O error.</em>
<a class="jxr_linenumber" name="305" href="#305">305</a> <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="306" href="#306">306</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> execute(
<a class="jxr_linenumber" name="307" href="#307">307</a>             <strong class="jxr_keyword">final</strong> <a href="../../../../../../org/apache/http/nio/reactor/IOEventDispatch.html">IOEventDispatch</a> eventDispatch) <strong class="jxr_keyword">throws</strong> InterruptedIOException, IOReactorException {
<a class="jxr_linenumber" name="308" href="#308">308</a>         Args.notNull(eventDispatch, <span class="jxr_string">"Event dispatcher"</span>);
<a class="jxr_linenumber" name="309" href="#309">309</a>         <strong class="jxr_keyword">synchronized</strong> (<strong class="jxr_keyword">this</strong>.statusLock) {
<a class="jxr_linenumber" name="310" href="#310">310</a>             <strong class="jxr_keyword">if</strong> (<strong class="jxr_keyword">this</strong>.status.compareTo(IOReactorStatus.SHUTDOWN_REQUEST) &gt;= 0) {
<a class="jxr_linenumber" name="311" href="#311">311</a>                 <strong class="jxr_keyword">this</strong>.status = IOReactorStatus.SHUT_DOWN;
<a class="jxr_linenumber" name="312" href="#312">312</a>                 <strong class="jxr_keyword">this</strong>.statusLock.notifyAll();
<a class="jxr_linenumber" name="313" href="#313">313</a>                 <strong class="jxr_keyword">return</strong>;
<a class="jxr_linenumber" name="314" href="#314">314</a>             }
<a class="jxr_linenumber" name="315" href="#315">315</a>             <strong class="jxr_keyword">if</strong> (<strong class="jxr_keyword">this</strong>.status.compareTo(IOReactorStatus.INACTIVE) != 0) {
<a class="jxr_linenumber" name="316" href="#316">316</a>                 <strong class="jxr_keyword">throw</strong> <strong class="jxr_keyword">new</strong> IllegalStateException(<span class="jxr_string">"Illegal state: "</span> + <strong class="jxr_keyword">this</strong>.status);
<a class="jxr_linenumber" name="317" href="#317">317</a>             }
<a class="jxr_linenumber" name="318" href="#318">318</a>             <strong class="jxr_keyword">this</strong>.status = IOReactorStatus.ACTIVE;
<a class="jxr_linenumber" name="319" href="#319">319</a>             <em class="jxr_comment">// Start I/O dispatchers</em>
<a class="jxr_linenumber" name="320" href="#320">320</a>             <strong class="jxr_keyword">for</strong> (<strong class="jxr_keyword">int</strong> i = 0; i &lt; <strong class="jxr_keyword">this</strong>.dispatchers.length; i++) {
<a class="jxr_linenumber" name="321" href="#321">321</a>                 <a href="../../../../../../org/apache/http/impl/nio/reactor/BaseIOReactor.html">BaseIOReactor</a> dispatcher = <strong class="jxr_keyword">new</strong> <a href="../../../../../../org/apache/http/impl/nio/reactor/BaseIOReactor.html">BaseIOReactor</a>(<strong class="jxr_keyword">this</strong>.selectTimeout, <strong class="jxr_keyword">this</strong>.interestOpsQueueing);
<a class="jxr_linenumber" name="322" href="#322">322</a>                 dispatcher.setExceptionHandler(exceptionHandler);
<a class="jxr_linenumber" name="323" href="#323">323</a>                 <strong class="jxr_keyword">this</strong>.dispatchers[i] = dispatcher;
<a class="jxr_linenumber" name="324" href="#324">324</a>             }
<a class="jxr_linenumber" name="325" href="#325">325</a>             <strong class="jxr_keyword">for</strong> (<strong class="jxr_keyword">int</strong> i = 0; i &lt; <strong class="jxr_keyword">this</strong>.workerCount; i++) {
<a class="jxr_linenumber" name="326" href="#326">326</a>                 <a href="../../../../../../org/apache/http/impl/nio/reactor/BaseIOReactor.html">BaseIOReactor</a> dispatcher = <strong class="jxr_keyword">this</strong>.dispatchers[i];
<a class="jxr_linenumber" name="327" href="#327">327</a>                 <strong class="jxr_keyword">this</strong>.workers[i] = <strong class="jxr_keyword">new</strong> <a href="../../../../../../org/apache/http/impl/nio/reactor/AbstractMultiworkerIOReactor.html">Worker</a>(dispatcher, eventDispatch);
<a class="jxr_linenumber" name="328" href="#328">328</a>                 <strong class="jxr_keyword">this</strong>.threads[i] = <strong class="jxr_keyword">this</strong>.threadFactory.newThread(<strong class="jxr_keyword">this</strong>.workers[i]);
<a class="jxr_linenumber" name="329" href="#329">329</a>             }
<a class="jxr_linenumber" name="330" href="#330">330</a>         }
<a class="jxr_linenumber" name="331" href="#331">331</a>         <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="332" href="#332">332</a> 
<a class="jxr_linenumber" name="333" href="#333">333</a>             <strong class="jxr_keyword">for</strong> (<strong class="jxr_keyword">int</strong> i = 0; i &lt; <strong class="jxr_keyword">this</strong>.workerCount; i++) {
<a class="jxr_linenumber" name="334" href="#334">334</a>                 <strong class="jxr_keyword">if</strong> (<strong class="jxr_keyword">this</strong>.status != IOReactorStatus.ACTIVE) {
<a class="jxr_linenumber" name="335" href="#335">335</a>                     <strong class="jxr_keyword">return</strong>;
<a class="jxr_linenumber" name="336" href="#336">336</a>                 }
<a class="jxr_linenumber" name="337" href="#337">337</a>                 <strong class="jxr_keyword">this</strong>.threads[i].start();
<a class="jxr_linenumber" name="338" href="#338">338</a>             }
<a class="jxr_linenumber" name="339" href="#339">339</a> 
<a class="jxr_linenumber" name="340" href="#340">340</a>             <strong class="jxr_keyword">for</strong> (;;) {
<a class="jxr_linenumber" name="341" href="#341">341</a>                 <strong class="jxr_keyword">int</strong> readyCount;
<a class="jxr_linenumber" name="342" href="#342">342</a>                 <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="343" href="#343">343</a>                     readyCount = <strong class="jxr_keyword">this</strong>.selector.select(<strong class="jxr_keyword">this</strong>.selectTimeout);
<a class="jxr_linenumber" name="344" href="#344">344</a>                 } <strong class="jxr_keyword">catch</strong> (InterruptedIOException ex) {
<a class="jxr_linenumber" name="345" href="#345">345</a>                     <strong class="jxr_keyword">throw</strong> ex;
<a class="jxr_linenumber" name="346" href="#346">346</a>                 } <strong class="jxr_keyword">catch</strong> (IOException ex) {
<a class="jxr_linenumber" name="347" href="#347">347</a>                     <strong class="jxr_keyword">throw</strong> <strong class="jxr_keyword">new</strong> <a href="../../../../../../org/apache/http/nio/reactor/IOReactorException.html">IOReactorException</a>(<span class="jxr_string">"Unexpected selector failure"</span>, ex);
<a class="jxr_linenumber" name="348" href="#348">348</a>                 }
<a class="jxr_linenumber" name="349" href="#349">349</a> 
<a class="jxr_linenumber" name="350" href="#350">350</a>                 <strong class="jxr_keyword">if</strong> (<strong class="jxr_keyword">this</strong>.status.compareTo(IOReactorStatus.ACTIVE) == 0) {
<a class="jxr_linenumber" name="351" href="#351">351</a>                     processEvents(readyCount);
<a class="jxr_linenumber" name="352" href="#352">352</a>                 }
<a class="jxr_linenumber" name="353" href="#353">353</a> 
<a class="jxr_linenumber" name="354" href="#354">354</a>                 <em class="jxr_comment">// Verify I/O dispatchers</em>
<a class="jxr_linenumber" name="355" href="#355">355</a>                 <strong class="jxr_keyword">for</strong> (<strong class="jxr_keyword">int</strong> i = 0; i &lt; <strong class="jxr_keyword">this</strong>.workerCount; i++) {
<a class="jxr_linenumber" name="356" href="#356">356</a>                     <a href="../../../../../../org/apache/http/impl/nio/reactor/AbstractMultiworkerIOReactor.html">Worker</a> worker = <strong class="jxr_keyword">this</strong>.workers[i];
<a class="jxr_linenumber" name="357" href="#357">357</a>                     Exception ex = worker.getException();
<a class="jxr_linenumber" name="358" href="#358">358</a>                     <strong class="jxr_keyword">if</strong> (ex != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="359" href="#359">359</a>                         <strong class="jxr_keyword">throw</strong> <strong class="jxr_keyword">new</strong> <a href="../../../../../../org/apache/http/nio/reactor/IOReactorException.html">IOReactorException</a>(
<a class="jxr_linenumber" name="360" href="#360">360</a>                                 <span class="jxr_string">"I/O dispatch worker terminated abnormally"</span>, ex);
<a class="jxr_linenumber" name="361" href="#361">361</a>                     }
<a class="jxr_linenumber" name="362" href="#362">362</a>                 }
<a class="jxr_linenumber" name="363" href="#363">363</a> 
<a class="jxr_linenumber" name="364" href="#364">364</a>                 <strong class="jxr_keyword">if</strong> (<strong class="jxr_keyword">this</strong>.status.compareTo(IOReactorStatus.ACTIVE) &gt; 0) {
<a class="jxr_linenumber" name="365" href="#365">365</a>                     <strong class="jxr_keyword">break</strong>;
<a class="jxr_linenumber" name="366" href="#366">366</a>                 }
<a class="jxr_linenumber" name="367" href="#367">367</a>             }
<a class="jxr_linenumber" name="368" href="#368">368</a> 
<a class="jxr_linenumber" name="369" href="#369">369</a>         } <strong class="jxr_keyword">catch</strong> (ClosedSelectorException ex) {
<a class="jxr_linenumber" name="370" href="#370">370</a>             addExceptionEvent(ex);
<a class="jxr_linenumber" name="371" href="#371">371</a>         } <strong class="jxr_keyword">catch</strong> (IOReactorException ex) {
<a class="jxr_linenumber" name="372" href="#372">372</a>             <strong class="jxr_keyword">if</strong> (ex.getCause() != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="373" href="#373">373</a>                 addExceptionEvent(ex.getCause());
<a class="jxr_linenumber" name="374" href="#374">374</a>             }
<a class="jxr_linenumber" name="375" href="#375">375</a>             <strong class="jxr_keyword">throw</strong> ex;
<a class="jxr_linenumber" name="376" href="#376">376</a>         } <strong class="jxr_keyword">finally</strong> {
<a class="jxr_linenumber" name="377" href="#377">377</a>             doShutdown();
<a class="jxr_linenumber" name="378" href="#378">378</a>             <strong class="jxr_keyword">synchronized</strong> (<strong class="jxr_keyword">this</strong>.statusLock) {
<a class="jxr_linenumber" name="379" href="#379">379</a>                 <strong class="jxr_keyword">this</strong>.status = IOReactorStatus.SHUT_DOWN;
<a class="jxr_linenumber" name="380" href="#380">380</a>                 <strong class="jxr_keyword">this</strong>.statusLock.notifyAll();
<a class="jxr_linenumber" name="381" href="#381">381</a>             }
<a class="jxr_linenumber" name="382" href="#382">382</a>         }
<a class="jxr_linenumber" name="383" href="#383">383</a>     }
<a class="jxr_linenumber" name="384" href="#384">384</a> 
<a class="jxr_linenumber" name="385" href="#385">385</a>     <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="386" href="#386">386</a> <em class="jxr_javadoccomment">     * Activates the shutdown sequence for this reactor. This method will cancel</em>
<a class="jxr_linenumber" name="387" href="#387">387</a> <em class="jxr_javadoccomment">     * all pending session requests, close out all active I/O channels,</em>
<a class="jxr_linenumber" name="388" href="#388">388</a> <em class="jxr_javadoccomment">     * make an attempt to terminate all worker I/O reactors gracefully,</em>
<a class="jxr_linenumber" name="389" href="#389">389</a> <em class="jxr_javadoccomment">     * and finally force-terminate those I/O reactors that failed to</em>
<a class="jxr_linenumber" name="390" href="#390">390</a> <em class="jxr_javadoccomment">     * terminate after the specified grace period.</em>
<a class="jxr_linenumber" name="391" href="#391">391</a> <em class="jxr_javadoccomment">     *</em>
<a class="jxr_linenumber" name="392" href="#392">392</a> <em class="jxr_javadoccomment">     * @throws InterruptedIOException if the shutdown sequence has been</em>
<a class="jxr_linenumber" name="393" href="#393">393</a> <em class="jxr_javadoccomment">     *   interrupted.</em>
<a class="jxr_linenumber" name="394" href="#394">394</a> <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="395" href="#395">395</a>     <strong class="jxr_keyword">protected</strong> <strong class="jxr_keyword">void</strong> doShutdown() <strong class="jxr_keyword">throws</strong> InterruptedIOException {
<a class="jxr_linenumber" name="396" href="#396">396</a>         <strong class="jxr_keyword">synchronized</strong> (<strong class="jxr_keyword">this</strong>.statusLock) {
<a class="jxr_linenumber" name="397" href="#397">397</a>             <strong class="jxr_keyword">if</strong> (<strong class="jxr_keyword">this</strong>.status.compareTo(IOReactorStatus.SHUTTING_DOWN) &gt;= 0) {
<a class="jxr_linenumber" name="398" href="#398">398</a>                 <strong class="jxr_keyword">return</strong>;
<a class="jxr_linenumber" name="399" href="#399">399</a>             }
<a class="jxr_linenumber" name="400" href="#400">400</a>             <strong class="jxr_keyword">this</strong>.status = IOReactorStatus.SHUTTING_DOWN;
<a class="jxr_linenumber" name="401" href="#401">401</a>         }
<a class="jxr_linenumber" name="402" href="#402">402</a>         <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="403" href="#403">403</a>             cancelRequests();
<a class="jxr_linenumber" name="404" href="#404">404</a>         } <strong class="jxr_keyword">catch</strong> (IOReactorException ex) {
<a class="jxr_linenumber" name="405" href="#405">405</a>             <strong class="jxr_keyword">if</strong> (ex.getCause() != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="406" href="#406">406</a>                 addExceptionEvent(ex.getCause());
<a class="jxr_linenumber" name="407" href="#407">407</a>             }
<a class="jxr_linenumber" name="408" href="#408">408</a>         }
<a class="jxr_linenumber" name="409" href="#409">409</a>         <strong class="jxr_keyword">this</strong>.selector.wakeup();
<a class="jxr_linenumber" name="410" href="#410">410</a> 
<a class="jxr_linenumber" name="411" href="#411">411</a>         <em class="jxr_comment">// Close out all channels</em>
<a class="jxr_linenumber" name="412" href="#412">412</a>         <strong class="jxr_keyword">if</strong> (<strong class="jxr_keyword">this</strong>.selector.isOpen()) {
<a class="jxr_linenumber" name="413" href="#413">413</a>             <strong class="jxr_keyword">for</strong> (SelectionKey key : <strong class="jxr_keyword">this</strong>.selector.keys()) {
<a class="jxr_linenumber" name="414" href="#414">414</a>                 <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="415" href="#415">415</a>                     Channel channel = key.channel();
<a class="jxr_linenumber" name="416" href="#416">416</a>                     <strong class="jxr_keyword">if</strong> (channel != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="417" href="#417">417</a>                         channel.close();
<a class="jxr_linenumber" name="418" href="#418">418</a>                     }
<a class="jxr_linenumber" name="419" href="#419">419</a>                 } <strong class="jxr_keyword">catch</strong> (IOException ex) {
<a class="jxr_linenumber" name="420" href="#420">420</a>                     addExceptionEvent(ex);
<a class="jxr_linenumber" name="421" href="#421">421</a>                 }
<a class="jxr_linenumber" name="422" href="#422">422</a>             }
<a class="jxr_linenumber" name="423" href="#423">423</a>             <em class="jxr_comment">// Stop dispatching I/O events</em>
<a class="jxr_linenumber" name="424" href="#424">424</a>             <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="425" href="#425">425</a>                 <strong class="jxr_keyword">this</strong>.selector.close();
<a class="jxr_linenumber" name="426" href="#426">426</a>             } <strong class="jxr_keyword">catch</strong> (IOException ex) {
<a class="jxr_linenumber" name="427" href="#427">427</a>                 addExceptionEvent(ex);
<a class="jxr_linenumber" name="428" href="#428">428</a>             }
<a class="jxr_linenumber" name="429" href="#429">429</a>         }
<a class="jxr_linenumber" name="430" href="#430">430</a> 
<a class="jxr_linenumber" name="431" href="#431">431</a>         <em class="jxr_comment">// Attempt to shut down I/O dispatchers gracefully</em>
<a class="jxr_linenumber" name="432" href="#432">432</a>         <strong class="jxr_keyword">for</strong> (<strong class="jxr_keyword">int</strong> i = 0; i &lt; <strong class="jxr_keyword">this</strong>.workerCount; i++) {
<a class="jxr_linenumber" name="433" href="#433">433</a>             <a href="../../../../../../org/apache/http/impl/nio/reactor/BaseIOReactor.html">BaseIOReactor</a> dispatcher = <strong class="jxr_keyword">this</strong>.dispatchers[i];
<a class="jxr_linenumber" name="434" href="#434">434</a>             dispatcher.gracefulShutdown();
<a class="jxr_linenumber" name="435" href="#435">435</a>         }
<a class="jxr_linenumber" name="436" href="#436">436</a> 
<a class="jxr_linenumber" name="437" href="#437">437</a>         <strong class="jxr_keyword">long</strong> gracePeriod = <strong class="jxr_keyword">this</strong>.config.getShutdownGracePeriod();
<a class="jxr_linenumber" name="438" href="#438">438</a> 
<a class="jxr_linenumber" name="439" href="#439">439</a>         <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="440" href="#440">440</a>             <em class="jxr_comment">// Force shut down I/O dispatchers if they fail to terminate</em>
<a class="jxr_linenumber" name="441" href="#441">441</a>             <em class="jxr_comment">// in time</em>
<a class="jxr_linenumber" name="442" href="#442">442</a>             <strong class="jxr_keyword">for</strong> (<strong class="jxr_keyword">int</strong> i = 0; i &lt; <strong class="jxr_keyword">this</strong>.workerCount; i++) {
<a class="jxr_linenumber" name="443" href="#443">443</a>                 <a href="../../../../../../org/apache/http/impl/nio/reactor/BaseIOReactor.html">BaseIOReactor</a> dispatcher = <strong class="jxr_keyword">this</strong>.dispatchers[i];
<a class="jxr_linenumber" name="444" href="#444">444</a>                 <strong class="jxr_keyword">if</strong> (dispatcher.getStatus() != IOReactorStatus.INACTIVE) {
<a class="jxr_linenumber" name="445" href="#445">445</a>                     dispatcher.awaitShutdown(gracePeriod);
<a class="jxr_linenumber" name="446" href="#446">446</a>                 }
<a class="jxr_linenumber" name="447" href="#447">447</a>                 <strong class="jxr_keyword">if</strong> (dispatcher.getStatus() != IOReactorStatus.SHUT_DOWN) {
<a class="jxr_linenumber" name="448" href="#448">448</a>                     <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="449" href="#449">449</a>                         dispatcher.hardShutdown();
<a class="jxr_linenumber" name="450" href="#450">450</a>                     } <strong class="jxr_keyword">catch</strong> (IOReactorException ex) {
<a class="jxr_linenumber" name="451" href="#451">451</a>                         <strong class="jxr_keyword">if</strong> (ex.getCause() != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="452" href="#452">452</a>                             addExceptionEvent(ex.getCause());
<a class="jxr_linenumber" name="453" href="#453">453</a>                         }
<a class="jxr_linenumber" name="454" href="#454">454</a>                     }
<a class="jxr_linenumber" name="455" href="#455">455</a>                 }
<a class="jxr_linenumber" name="456" href="#456">456</a>             }
<a class="jxr_linenumber" name="457" href="#457">457</a>             <em class="jxr_comment">// Join worker threads</em>
<a class="jxr_linenumber" name="458" href="#458">458</a>             <strong class="jxr_keyword">for</strong> (<strong class="jxr_keyword">int</strong> i = 0; i &lt; <strong class="jxr_keyword">this</strong>.workerCount; i++) {
<a class="jxr_linenumber" name="459" href="#459">459</a>                 Thread t = <strong class="jxr_keyword">this</strong>.threads[i];
<a class="jxr_linenumber" name="460" href="#460">460</a>                 <strong class="jxr_keyword">if</strong> (t != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="461" href="#461">461</a>                     t.join(gracePeriod);
<a class="jxr_linenumber" name="462" href="#462">462</a>                 }
<a class="jxr_linenumber" name="463" href="#463">463</a>             }
<a class="jxr_linenumber" name="464" href="#464">464</a>         } <strong class="jxr_keyword">catch</strong> (InterruptedException ex) {
<a class="jxr_linenumber" name="465" href="#465">465</a>             <strong class="jxr_keyword">throw</strong> <strong class="jxr_keyword">new</strong> InterruptedIOException(ex.getMessage());
<a class="jxr_linenumber" name="466" href="#466">466</a>         }
<a class="jxr_linenumber" name="467" href="#467">467</a>     }
<a class="jxr_linenumber" name="468" href="#468">468</a> 
<a class="jxr_linenumber" name="469" href="#469">469</a>     <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="470" href="#470">470</a> <em class="jxr_javadoccomment">     * Assigns the given channel entry to one of the worker I/O reactors.</em>
<a class="jxr_linenumber" name="471" href="#471">471</a> <em class="jxr_javadoccomment">     *</em>
<a class="jxr_linenumber" name="472" href="#472">472</a> <em class="jxr_javadoccomment">     * @param entry the channel entry.</em>
<a class="jxr_linenumber" name="473" href="#473">473</a> <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="474" href="#474">474</a>     <strong class="jxr_keyword">protected</strong> <strong class="jxr_keyword">void</strong> addChannel(<strong class="jxr_keyword">final</strong> <a href="../../../../../../org/apache/http/impl/nio/reactor/ChannelEntry.html">ChannelEntry</a> entry) {
<a class="jxr_linenumber" name="475" href="#475">475</a>         <em class="jxr_comment">// Distribute new channels among the workers</em>
<a class="jxr_linenumber" name="476" href="#476">476</a>         <strong class="jxr_keyword">int</strong> i = Math.abs(<strong class="jxr_keyword">this</strong>.currentWorker++ % <strong class="jxr_keyword">this</strong>.workerCount);
<a class="jxr_linenumber" name="477" href="#477">477</a>         <strong class="jxr_keyword">this</strong>.dispatchers[i].addChannel(entry);
<a class="jxr_linenumber" name="478" href="#478">478</a>     }
<a class="jxr_linenumber" name="479" href="#479">479</a> 
<a class="jxr_linenumber" name="480" href="#480">480</a>     <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="481" href="#481">481</a> <em class="jxr_javadoccomment">     * Registers the given channel with the main {@link Selector}.</em>
<a class="jxr_linenumber" name="482" href="#482">482</a> <em class="jxr_javadoccomment">     *</em>
<a class="jxr_linenumber" name="483" href="#483">483</a> <em class="jxr_javadoccomment">     * @param channel the channel.</em>
<a class="jxr_linenumber" name="484" href="#484">484</a> <em class="jxr_javadoccomment">     * @param ops interest ops.</em>
<a class="jxr_linenumber" name="485" href="#485">485</a> <em class="jxr_javadoccomment">     * @return  selection key.</em>
<a class="jxr_linenumber" name="486" href="#486">486</a> <em class="jxr_javadoccomment">     * @throws ClosedChannelException if the channel has been already closed.</em>
<a class="jxr_linenumber" name="487" href="#487">487</a> <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="488" href="#488">488</a>     <strong class="jxr_keyword">protected</strong> SelectionKey registerChannel(
<a class="jxr_linenumber" name="489" href="#489">489</a>             <strong class="jxr_keyword">final</strong> SelectableChannel channel, <strong class="jxr_keyword">int</strong> ops) <strong class="jxr_keyword">throws</strong> ClosedChannelException {
<a class="jxr_linenumber" name="490" href="#490">490</a>         <strong class="jxr_keyword">return</strong> channel.register(<strong class="jxr_keyword">this</strong>.selector, ops);
<a class="jxr_linenumber" name="491" href="#491">491</a>     }
<a class="jxr_linenumber" name="492" href="#492">492</a> 
<a class="jxr_linenumber" name="493" href="#493">493</a>     <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="494" href="#494">494</a> <em class="jxr_javadoccomment">     * Prepares the given {@link Socket} by resetting some of its properties.</em>
<a class="jxr_linenumber" name="495" href="#495">495</a> <em class="jxr_javadoccomment">     *</em>
<a class="jxr_linenumber" name="496" href="#496">496</a> <em class="jxr_javadoccomment">     * @param socket the socket</em>
<a class="jxr_linenumber" name="497" href="#497">497</a> <em class="jxr_javadoccomment">     * @throws IOException in case of an I/O error.</em>
<a class="jxr_linenumber" name="498" href="#498">498</a> <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="499" href="#499">499</a>     <strong class="jxr_keyword">protected</strong> <strong class="jxr_keyword">void</strong> prepareSocket(<strong class="jxr_keyword">final</strong> Socket socket) <strong class="jxr_keyword">throws</strong> IOException {
<a class="jxr_linenumber" name="500" href="#500">500</a>         socket.setTcpNoDelay(<strong class="jxr_keyword">this</strong>.config.isTcpNoDelay());
<a class="jxr_linenumber" name="501" href="#501">501</a>         socket.setSoTimeout(<strong class="jxr_keyword">this</strong>.config.getSoTimeout());
<a class="jxr_linenumber" name="502" href="#502">502</a>         socket.setKeepAlive(<strong class="jxr_keyword">this</strong>.config.isSoKeepalive());
<a class="jxr_linenumber" name="503" href="#503">503</a>         <strong class="jxr_keyword">int</strong> linger = <strong class="jxr_keyword">this</strong>.config.getSoLinger();
<a class="jxr_linenumber" name="504" href="#504">504</a>         <strong class="jxr_keyword">if</strong> (linger &gt;= 0) {
<a class="jxr_linenumber" name="505" href="#505">505</a>             socket.setSoLinger(linger &gt; 0, linger);
<a class="jxr_linenumber" name="506" href="#506">506</a>         }
<a class="jxr_linenumber" name="507" href="#507">507</a>     }
<a class="jxr_linenumber" name="508" href="#508">508</a> 
<a class="jxr_linenumber" name="509" href="#509">509</a>     <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="510" href="#510">510</a> <em class="jxr_javadoccomment">     * Blocks for the given period of time in milliseconds awaiting</em>
<a class="jxr_linenumber" name="511" href="#511">511</a> <em class="jxr_javadoccomment">     * the completion of the reactor shutdown. If the value of</em>
<a class="jxr_linenumber" name="512" href="#512">512</a> <em class="jxr_javadoccomment">     * &lt;code&gt;timeout&lt;/code&gt; is set to &lt;code&gt;0&lt;/code&gt; this method blocks</em>
<a class="jxr_linenumber" name="513" href="#513">513</a> <em class="jxr_javadoccomment">     * indefinitely.</em>
<a class="jxr_linenumber" name="514" href="#514">514</a> <em class="jxr_javadoccomment">     *</em>
<a class="jxr_linenumber" name="515" href="#515">515</a> <em class="jxr_javadoccomment">     * @param timeout the maximum wait time.</em>
<a class="jxr_linenumber" name="516" href="#516">516</a> <em class="jxr_javadoccomment">     * @throws InterruptedException if interrupted.</em>
<a class="jxr_linenumber" name="517" href="#517">517</a> <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="518" href="#518">518</a>     <strong class="jxr_keyword">protected</strong> <strong class="jxr_keyword">void</strong> awaitShutdown(<strong class="jxr_keyword">long</strong> timeout) <strong class="jxr_keyword">throws</strong> InterruptedException {
<a class="jxr_linenumber" name="519" href="#519">519</a>         <strong class="jxr_keyword">synchronized</strong> (<strong class="jxr_keyword">this</strong>.statusLock) {
<a class="jxr_linenumber" name="520" href="#520">520</a>             <strong class="jxr_keyword">long</strong> deadline = System.currentTimeMillis() + timeout;
<a class="jxr_linenumber" name="521" href="#521">521</a>             <strong class="jxr_keyword">long</strong> remaining = timeout;
<a class="jxr_linenumber" name="522" href="#522">522</a>             <strong class="jxr_keyword">while</strong> (<strong class="jxr_keyword">this</strong>.status != IOReactorStatus.SHUT_DOWN) {
<a class="jxr_linenumber" name="523" href="#523">523</a>                 <strong class="jxr_keyword">this</strong>.statusLock.wait(remaining);
<a class="jxr_linenumber" name="524" href="#524">524</a>                 <strong class="jxr_keyword">if</strong> (timeout &gt; 0) {
<a class="jxr_linenumber" name="525" href="#525">525</a>                     remaining = deadline - System.currentTimeMillis();
<a class="jxr_linenumber" name="526" href="#526">526</a>                     <strong class="jxr_keyword">if</strong> (remaining &lt;= 0) {
<a class="jxr_linenumber" name="527" href="#527">527</a>                         <strong class="jxr_keyword">break</strong>;
<a class="jxr_linenumber" name="528" href="#528">528</a>                     }
<a class="jxr_linenumber" name="529" href="#529">529</a>                 }
<a class="jxr_linenumber" name="530" href="#530">530</a>             }
<a class="jxr_linenumber" name="531" href="#531">531</a>         }
<a class="jxr_linenumber" name="532" href="#532">532</a>     }
<a class="jxr_linenumber" name="533" href="#533">533</a> 
<a class="jxr_linenumber" name="534" href="#534">534</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> shutdown() <strong class="jxr_keyword">throws</strong> IOException {
<a class="jxr_linenumber" name="535" href="#535">535</a>         shutdown(2000);
<a class="jxr_linenumber" name="536" href="#536">536</a>     }
<a class="jxr_linenumber" name="537" href="#537">537</a> 
<a class="jxr_linenumber" name="538" href="#538">538</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> shutdown(<strong class="jxr_keyword">long</strong> waitMs) <strong class="jxr_keyword">throws</strong> IOException {
<a class="jxr_linenumber" name="539" href="#539">539</a>         <strong class="jxr_keyword">synchronized</strong> (<strong class="jxr_keyword">this</strong>.statusLock) {
<a class="jxr_linenumber" name="540" href="#540">540</a>             <strong class="jxr_keyword">if</strong> (<strong class="jxr_keyword">this</strong>.status.compareTo(IOReactorStatus.ACTIVE) &gt; 0) {
<a class="jxr_linenumber" name="541" href="#541">541</a>                 <strong class="jxr_keyword">return</strong>;
<a class="jxr_linenumber" name="542" href="#542">542</a>             }
<a class="jxr_linenumber" name="543" href="#543">543</a>             <strong class="jxr_keyword">if</strong> (<strong class="jxr_keyword">this</strong>.status.compareTo(IOReactorStatus.INACTIVE) == 0) {
<a class="jxr_linenumber" name="544" href="#544">544</a>                 <strong class="jxr_keyword">this</strong>.status = IOReactorStatus.SHUT_DOWN;
<a class="jxr_linenumber" name="545" href="#545">545</a>                 cancelRequests();
<a class="jxr_linenumber" name="546" href="#546">546</a>                 <strong class="jxr_keyword">return</strong>;
<a class="jxr_linenumber" name="547" href="#547">547</a>             }
<a class="jxr_linenumber" name="548" href="#548">548</a>             <strong class="jxr_keyword">this</strong>.status = IOReactorStatus.SHUTDOWN_REQUEST;
<a class="jxr_linenumber" name="549" href="#549">549</a>         }
<a class="jxr_linenumber" name="550" href="#550">550</a>         <strong class="jxr_keyword">this</strong>.selector.wakeup();
<a class="jxr_linenumber" name="551" href="#551">551</a>         <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="552" href="#552">552</a>             awaitShutdown(waitMs);
<a class="jxr_linenumber" name="553" href="#553">553</a>         } <strong class="jxr_keyword">catch</strong> (InterruptedException ignore) {
<a class="jxr_linenumber" name="554" href="#554">554</a>         }
<a class="jxr_linenumber" name="555" href="#555">555</a>     }
<a class="jxr_linenumber" name="556" href="#556">556</a> 
<a class="jxr_linenumber" name="557" href="#557">557</a>     <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">void</strong> closeChannel(<strong class="jxr_keyword">final</strong> Channel channel) {
<a class="jxr_linenumber" name="558" href="#558">558</a>         <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="559" href="#559">559</a>             channel.close();
<a class="jxr_linenumber" name="560" href="#560">560</a>         } <strong class="jxr_keyword">catch</strong> (IOException ignore) {
<a class="jxr_linenumber" name="561" href="#561">561</a>         }
<a class="jxr_linenumber" name="562" href="#562">562</a>     }
<a class="jxr_linenumber" name="563" href="#563">563</a> 
<a class="jxr_linenumber" name="564" href="#564">564</a>     <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../../../org/apache/http/impl/nio/reactor/AbstractMultiworkerIOReactor.html">Worker</a> <strong class="jxr_keyword">implements</strong> Runnable {
<a class="jxr_linenumber" name="565" href="#565">565</a> 
<a class="jxr_linenumber" name="566" href="#566">566</a>         <strong class="jxr_keyword">final</strong> <a href="../../../../../../org/apache/http/impl/nio/reactor/BaseIOReactor.html">BaseIOReactor</a> dispatcher;
<a class="jxr_linenumber" name="567" href="#567">567</a>         <strong class="jxr_keyword">final</strong> <a href="../../../../../../org/apache/http/nio/reactor/IOEventDispatch.html">IOEventDispatch</a> eventDispatch;
<a class="jxr_linenumber" name="568" href="#568">568</a> 
<a class="jxr_linenumber" name="569" href="#569">569</a>         <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">volatile</strong> Exception exception;
<a class="jxr_linenumber" name="570" href="#570">570</a> 
<a class="jxr_linenumber" name="571" href="#571">571</a>         <strong class="jxr_keyword">public</strong> <a href="../../../../../../org/apache/http/impl/nio/reactor/AbstractMultiworkerIOReactor.html">Worker</a>(<strong class="jxr_keyword">final</strong> <a href="../../../../../../org/apache/http/impl/nio/reactor/BaseIOReactor.html">BaseIOReactor</a> dispatcher, <strong class="jxr_keyword">final</strong> <a href="../../../../../../org/apache/http/nio/reactor/IOEventDispatch.html">IOEventDispatch</a> eventDispatch) {
<a class="jxr_linenumber" name="572" href="#572">572</a>             <strong class="jxr_keyword">super</strong>();
<a class="jxr_linenumber" name="573" href="#573">573</a>             <strong class="jxr_keyword">this</strong>.dispatcher = dispatcher;
<a class="jxr_linenumber" name="574" href="#574">574</a>             <strong class="jxr_keyword">this</strong>.eventDispatch = eventDispatch;
<a class="jxr_linenumber" name="575" href="#575">575</a>         }
<a class="jxr_linenumber" name="576" href="#576">576</a> 
<a class="jxr_linenumber" name="577" href="#577">577</a>         <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> run() {
<a class="jxr_linenumber" name="578" href="#578">578</a>             <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="579" href="#579">579</a>                 <strong class="jxr_keyword">this</strong>.dispatcher.execute(<strong class="jxr_keyword">this</strong>.eventDispatch);
<a class="jxr_linenumber" name="580" href="#580">580</a>             } <strong class="jxr_keyword">catch</strong> (Exception ex) {
<a class="jxr_linenumber" name="581" href="#581">581</a>                 <strong class="jxr_keyword">this</strong>.exception = ex;
<a class="jxr_linenumber" name="582" href="#582">582</a>             }
<a class="jxr_linenumber" name="583" href="#583">583</a>         }
<a class="jxr_linenumber" name="584" href="#584">584</a> 
<a class="jxr_linenumber" name="585" href="#585">585</a>         <strong class="jxr_keyword">public</strong> Exception getException() {
<a class="jxr_linenumber" name="586" href="#586">586</a>             <strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">this</strong>.exception;
<a class="jxr_linenumber" name="587" href="#587">587</a>         }
<a class="jxr_linenumber" name="588" href="#588">588</a> 
<a class="jxr_linenumber" name="589" href="#589">589</a>     }
<a class="jxr_linenumber" name="590" href="#590">590</a> 
<a class="jxr_linenumber" name="591" href="#591">591</a>     <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../../../org/apache/http/impl/nio/reactor/AbstractMultiworkerIOReactor.html">DefaultThreadFactory</a> <strong class="jxr_keyword">implements</strong> ThreadFactory {
<a class="jxr_linenumber" name="592" href="#592">592</a> 
<a class="jxr_linenumber" name="593" href="#593">593</a>         <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">volatile</strong> <strong class="jxr_keyword">int</strong> COUNT = 0;
<a class="jxr_linenumber" name="594" href="#594">594</a> 
<a class="jxr_linenumber" name="595" href="#595">595</a>         <strong class="jxr_keyword">public</strong> Thread newThread(<strong class="jxr_keyword">final</strong> Runnable r) {
<a class="jxr_linenumber" name="596" href="#596">596</a>             <strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">new</strong> Thread(r, <span class="jxr_string">"I/O dispatcher "</span> + (++COUNT));
<a class="jxr_linenumber" name="597" href="#597">597</a>         }
<a class="jxr_linenumber" name="598" href="#598">598</a> 
<a class="jxr_linenumber" name="599" href="#599">599</a>     }
<a class="jxr_linenumber" name="600" href="#600">600</a> 
<a class="jxr_linenumber" name="601" href="#601">601</a> }
</pre>
<hr/><div id="footer">This page was automatically generated by <a href="http://maven.apache.org/">Maven</a></div></body>
</html>

